net.sf.saxon.value

## Class DayTimeDurationValue

- java.lang.Object
- - net.sf.saxon.om.AbstractItem
  - - net.sf.saxon.value.AtomicValue
    - - net.sf.saxon.value.DurationValue
      - - net.sf.saxon.value.DayTimeDurationValue

- All Implemented Interfaces:
    Comparable, PullEvent, AtomicSequence, GroundedValue, IdentityComparable, Item, Sequence, ConversionResult

      public final class DayTimeDurationValue
      extends DurationValue
      implements Comparable

  A value of type xs:dayTimeDuration

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.value.DurationValue

      `microseconds, months, negative, seconds`

    - ### Fields inherited from class net.sf.saxon.value.AtomicValue

      `typeLabel`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DayTimeDurationValue(int sign, int days, int hours, int minutes, long seconds, int microseconds)` Create a dayTimeDuration given the number of days, hours, minutes, and seconds.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `DurationValue` | `add(DurationValue other)` Add two dayTimeDurations
    `int` | `compareTo(Object other)` Compare the value to another duration value
    `AtomicValue` | `copyAsSubType(AtomicType typeLabel)` Create a copy of this atomic value, with a different type label
    `DecimalValue` | `divide(DurationValue other)` Find the ratio between two durations
    `static DayTimeDurationValue` | `fromMicroseconds(long microseconds)` Construct a duration value as a number of microseconds.
    `static DayTimeDurationValue` | `fromMilliseconds(long milliseconds)` Construct a duration value as a number of milliseconds.
    `static DayTimeDurationValue` | `fromSeconds(BigDecimal seconds)` Construct a duration value as a number of seconds.
    `long` | `getLengthInMicroseconds()` Get length of duration in microseconds, as a long
    `double` | `getLengthInSeconds()` Get length of duration in seconds
    `CharSequence` | `getPrimitiveStringValue()` Convert to string
    `BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
    `Object` | `getXPathComparable(boolean ordered, StringCollator collator, XPathContext context)` Get a Comparable value that implements the XPath ordering comparison semantics for this value.
    `static ConversionResult` | `makeDayTimeDurationValue(CharSequence s)` Factory method: create a duration value from a supplied string, in ISO 8601 format [-]PnDTnHnMnS
    `DurationValue` | `multiply(double n)` Multiply duration by a number.
    `DurationValue` | `negate()` Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
    `DurationValue` | `subtract(DurationValue other)` Subtract two dayTime-durations

    - ### Methods inherited from class net.sf.saxon.value.DurationValue

      `badDuration, badDuration, equals, getComponent, getDays, getHours, getMicroseconds, getMinutes, getMonths, getSchemaComparable, getSchemaComparable, getSeconds, getTotalMonths, getTotalSeconds, getYears, hashCode, makeDuration, makeDuration, normalizeDuration, normalizeZeroDuration, signum, simpleInteger`

    - ### Methods inherited from class net.sf.saxon.value.AtomicValue

      `asAtomic, checkPermittedContents, effectiveBooleanValue, getCanonicalLexicalRepresentation, getCardinality, getItemType, getStringValue, getStringValueCS, head, isIdentical, isIdentical, isNaN, itemAt, iterate, process, setTypeLabel, toString`

    - ### Methods inherited from class net.sf.saxon.om.AbstractItem

      `getLength, reduce, subsequence`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.AtomicSequence

      `getLength`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `reduce, subsequence`

- - ### Constructor Detail

    - #### DayTimeDurationValue

          public DayTimeDurationValue(int sign,
                              int days,
                              int hours,
                              int minutes,
                              long seconds,
                              int microseconds)
                               throws IllegalArgumentException

      Create a dayTimeDuration given the number of days, hours, minutes, and seconds. This constructor performs no validation. The components (apart from sign) must all be non-negative integers; they need not be normalized (for example, 36 hours is acceptable)
      Parameters:
        `sign` - positive number for positive durations, negative for negative duratoins
        `days` - number of days
        `hours` - number of hours
        `minutes` - number of minutes
        `seconds` - number of seconds
        `microseconds` - number of microseconds
      Throws:
        `IllegalArgumentException` - if the value is out of range; specifically, if the total number of seconds exceeds 2^63; or if any of the values is negative

  - ### Method Detail

    - #### makeDayTimeDurationValue

          public static ConversionResult makeDayTimeDurationValue(CharSequence s)

      Factory method: create a duration value from a supplied string, in ISO 8601 format [-]PnDTnHnMnS
      Parameters:
        `s` - the lexical representation of the xs:dayTimeDuration value
      Returns:
        a DayTimeDurationValue if the format is correct, or a ValidationErrorValue if not

    - #### copyAsSubType

          public AtomicValue copyAsSubType(AtomicType typeLabel)

      Create a copy of this atomic value, with a different type label
      Overrides:
        `copyAsSubType` in class `DurationValue`
      Parameters:
        `typeLabel` - the type label of the new copy. The caller is responsible for checking that the value actually conforms to this type.
      Returns:
        the copied value

    - #### getPrimitiveType

          public BuiltInAtomicType getPrimitiveType()

      Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.
      Overrides:
        `getPrimitiveType` in class `DurationValue`
      Returns:
        the primitive type

    - #### getPrimitiveStringValue

          public CharSequence getPrimitiveStringValue()

      Convert to string
      Overrides:
        `getPrimitiveStringValue` in class `DurationValue`
      Returns:
        ISO 8601 representation.

    - #### getLengthInSeconds

          public double getLengthInSeconds()

      Get length of duration in seconds
      Overrides:
        `getLengthInSeconds` in class `DurationValue`
      Returns:
        the duration in seconds, as a double

    - #### getLengthInMicroseconds

          public long getLengthInMicroseconds()

      Get length of duration in microseconds, as a long
      Returns:
        the length in microseconds

    - #### fromSeconds

          public static DayTimeDurationValue fromSeconds(BigDecimal seconds)

      Construct a duration value as a number of seconds.
      Parameters:
        `seconds` - the number of seconds in the duration. May be negative
      Returns:
        the xs:dayTimeDuration value with the specified length

    - #### fromMilliseconds

          public static DayTimeDurationValue fromMilliseconds(long milliseconds)
                                                       throws ValidationException

      Construct a duration value as a number of milliseconds.
      Parameters:
        `milliseconds` - the number of milliseconds in the duration (may be negative)
      Returns:
        the corresponding xs:dayTimeDuration value
      Throws:
        `ValidationException` - if implementation-defined limits are exceeded, specifically if the total number of seconds exceeds 2^63.

    - #### fromMicroseconds

          public static DayTimeDurationValue fromMicroseconds(long microseconds)
                                                       throws IllegalArgumentException

      Construct a duration value as a number of microseconds.
      Parameters:
        `microseconds` - the number of microseconds in the duration. The maximum and minimum limits are such that the number of days in the duration must fit in a 32-bit signed integer.
      Returns:
        the xs:dayTimeDuration represented by the given number of microseconds
      Throws:
        `IllegalArgumentException` - if the value is out of range.

    - #### multiply

          public DurationValue multiply(double n)
                                 throws XPathException

      Multiply duration by a number. This is also used when dividing a duration by a number.
      Overrides:
        `multiply` in class `DurationValue`
      Parameters:
        `n` - the number to multiply by
      Returns:
        the result of the multiplication
      Throws:
        `XPathException`

    - #### divide

          public DecimalValue divide(DurationValue other)
                              throws XPathException

      Find the ratio between two durations
      Overrides:
        `divide` in class `DurationValue`
      Parameters:
        `other` - the dividend
      Returns:
        the ratio, as a decimal
      Throws:
        `XPathException`

    - #### add

          public DurationValue add(DurationValue other)
                            throws XPathException

      Add two dayTimeDurations
      Overrides:
        `add` in class `DurationValue`
      Parameters:
        `other` - the duration to be added to this one
      Returns:
        the sum of the two durations
      Throws:
        `XPathException`

    - #### subtract

          public DurationValue subtract(DurationValue other)
                                 throws XPathException

      Subtract two dayTime-durations
      Overrides:
        `subtract` in class `DurationValue`
      Parameters:
        `other` - the duration to be subtracted from this one
      Returns:
        the difference of the two durations
      Throws:
        `XPathException`

    - #### negate

          public DurationValue negate()
                               throws IllegalArgumentException

      Negate a duration (same as subtracting from zero, but it preserves the type of the original duration)
      Overrides:
        `negate` in class `DurationValue`
      Returns:
        the original duration with its sign reversed, retaining its type
      Throws:
        `IllegalArgumentException` - in the extremely unlikely event that the duration is one that cannot be negated (because the limit for positive durations is one second off from the limit for negative durations)

    - #### compareTo

          public int compareTo(Object other)

      Compare the value to another duration value
      Specified by:
        `compareTo` in interface `Comparable`
      Parameters:
        `other` - The other dateTime value
      Returns:
        negative value if this one is the earler, 0 if they are chronologically equal, positive value if this one is the later. For this purpose, dateTime values with an unknown timezone are considered to be UTC values (the Comparable interface requires a total ordering).
      Throws:
        `ClassCastException` - if the other value is not a DateTimeValue (the parameter is declared as Object to satisfy the Comparable interface)

    - #### getXPathComparable

          public Object getXPathComparable(boolean ordered,
                                  StringCollator collator,
                                  XPathContext context)

      Get a Comparable value that implements the XPath ordering comparison semantics for this value. Returns null if the value is not comparable according to XPath rules. The default implementation returns the value itself. This is modified for types such as xs:duration which allow ordering comparisons in XML Schema, but not in XPath.
      Overrides:
        `getXPathComparable` in class `DurationValue`
      Parameters:
        `ordered` - true if an ordered comparable is needed
        `collator` - Collation used for string comparison
        `context` - XPath dynamic context
      Returns:
        an Object whose equals() and hashCode() methods implement the XPath comparison semantics with respect to this atomic value. If ordered is specified, the result will either be null if no ordering is defined, or will be a Comparable

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.